"use strict";

require("core-js/modules/es6.object.define-property");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.string.iterator");

require("core-js/modules/es6.weak-map");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("core-js/modules/es6.object.assign");

require("core-js/modules/es6.promise");

require("core-js/modules/es6.regexp.to-string");

require("core-js/modules/es6.date.to-string");

require("core-js/modules/es6.object.to-string");

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.is-array");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

require("regenerator-runtime/runtime");

require("core-js/modules/es6.regexp.replace");

require("core-js/modules/es6.regexp.search");

var _react = _interopRequireWildcard(require("react"));

var _ExecutionEnvironment = _interopRequireDefault(require("fbjs/lib/ExecutionEnvironment"));

var _reactRouterDom = require("react-router-dom");

var _ErrorCatch = _interopRequireDefault(require("./ErrorCatch"));

var _getPage = _interopRequireDefault(require("./getPage"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var isMounted = false;
/** @react use to control page */

var Root = function Root(_ref) {
  var Main = _ref.Main,
      Loading = _ref.Loading,
      Error = _ref.Error,
      routesData = _ref.routesData,
      InitialPage = _ref.InitialPage,
      mainInitialProps = _ref.mainInitialProps,
      pageInitialProps = _ref.pageInitialProps,
      _ref$location = _ref.location,
      pathname = _ref$location.pathname,
      search = _ref$location.search;
  var isServer = !_ExecutionEnvironment["default"].canUseEventListeners;
  var ctx = isServer ? {} : {
    path: pathname,
    querystring: search.replace(/\?/, ''),
    originalUrl: "".concat(pathname).concat(search),
    origin: window.location.origin,
    href: window.location.href,
    host: window.location.host,
    hostname: window.location.hostname,
    protocol: window.location.protocol
  };

  var _useState = (0, _react.useState)({
    Page: InitialPage,
    mainProps: mainInitialProps,
    pageProps: pageInitialProps
  }),
      _useState2 = _slicedToArray(_useState, 2),
      _useState2$ = _useState2[0],
      Page = _useState2$.Page,
      mainProps = _useState2$.mainProps,
      pageProps = _useState2$.pageProps,
      updatePage = _useState2[1];

  var prevCtxRef = (0, _react.useRef)(ctx);
  (0, _react.useEffect)(function () {
    var cancel = false;
    prevCtxRef.current = ctx;
    if (!isServer && isMounted) _asyncToGenerator(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee() {
      var newPageData;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return (0, _getPage["default"])(Main, routesData, ctx, isServer);

            case 2:
              newPageData = _context.sent;

              if (!cancel) {
                _context.next = 5;
                break;
              }

              return _context.abrupt("return");

            case 5:
              updatePage(newPageData);

            case 6:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }))();
    if (!isMounted) isMounted = true;
    return function () {
      cancel = true;
    };
  }, [ctx.originalUrl]);
  var prevCtx = prevCtxRef.current;
  return _react["default"].createElement(_ErrorCatch["default"], {
    Error: Error
  }, _react["default"].createElement(Main, _extends({}, mainProps, {
    Component: Page
  }), function (props) {
    return prevCtx.originalUrl !== ctx.originalUrl ? _react["default"].createElement(Loading, null) : _react["default"].createElement(Page, _extends({}, props, pageProps));
  }));
};

var _default = _react["default"].memo((0, _reactRouterDom.withRouter)(Root));

exports["default"] = _default;
module.exports = exports.default;