"use strict";

require("core-js/modules/es6.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("core-js/modules/es6.array.index-of");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

require("core-js/modules/es6.regexp.to-string");

require("core-js/modules/es6.date.to-string");

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.is-array");

require("core-js/modules/es6.promise");

require("core-js/modules/es6.object.to-string");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

require("core-js/modules/es6.regexp.match");

require("regenerator-runtime/runtime");

var _reactIs = require("react-is");

var _server = require("react-dom/server");

var _reactRouterConfig = require("react-router-config");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

/**
 * @example
 * getPage(Main, routesData, ctx, true)
 *
 * @param {rootPropsType.Main} Main - Main Component
 * @param {rootPropsType.routesData} routesData - routes data
 * @param {{ [string]: string }} ctx - context from react-router
 * @param {boolean} isServer - check is Server
 *
 * @return {rootPropsType['InitialPage' | 'mainInitialProps' | 'pageInitialProps']} - the data for rendering page
 */
var _default =
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee(Main, routesData, ctx, isServer) {
    var _getInitialProps, _ref4, _getInitialProps2, _ref6;

    var _matchRoutes, _matchRoutes2, _matchRoutes2$, _matchRoutes2$$route$, loader, chunkName, match, _ref2, Page, _ref3, pageHead, pageProps, _ref5, mainHead, mainProps;

    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _matchRoutes = (0, _reactRouterConfig.matchRoutes)(routesData, ctx.path), _matchRoutes2 = _slicedToArray(_matchRoutes, 1), _matchRoutes2$ = _matchRoutes2[0], _matchRoutes2$$route$ = _matchRoutes2$.route.component, loader = _matchRoutes2$$route$.loader, chunkName = _matchRoutes2$$route$.chunkName, match = _matchRoutes2$.match;
            _context.next = 3;
            return loader();

          case 3:
            _ref2 = _context.sent;
            Page = _ref2["default"];
            _context.next = 7;
            return (_getInitialProps = (_ref4 = !(0, _reactIs.isMemo)(Page) ? Page : Page.type).getInitialProps) === null || _getInitialProps === void 0 ? void 0 : _getInitialProps.call(_ref4, {
              ctx: ctx,
              isServer: isServer,
              match: match
            });

          case 7:
            _context.t0 = _context.sent;

            if (_context.t0) {
              _context.next = 10;
              break;
            }

            _context.t0 = {};

          case 10:
            _ref3 = _context.t0;
            pageHead = _ref3.head;
            pageProps = _objectWithoutProperties(_ref3, ["head"]);
            _context.next = 15;
            return (_getInitialProps2 = (_ref6 = !(0, _reactIs.isMemo)(Main) ? Main : Main.type).getInitialProps) === null || _getInitialProps2 === void 0 ? void 0 : _getInitialProps2.call(_ref6, {
              ctx: ctx,
              isServer: isServer,
              Component: Page,
              pageProps: pageProps
            });

          case 15:
            _context.t1 = _context.sent;

            if (_context.t1) {
              _context.next = 18;
              break;
            }

            _context.t1 = {};

          case 18:
            _ref5 = _context.t1;
            mainHead = _ref5.head;
            mainProps = _objectWithoutProperties(_ref5, ["head"]);
            (0, _server.renderToStaticMarkup)(mainHead || null);
            (0, _server.renderToStaticMarkup)(pageHead || null);
            return _context.abrupt("return", {
              Page: Page,
              mainProps: mainProps,
              pageProps: pageProps,
              chunkName: chunkName
            });

          case 24:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function (_x, _x2, _x3, _x4) {
    return _ref.apply(this, arguments);
  };
}();

exports["default"] = _default;
module.exports = exports.default;