"use strict";

require("core-js/modules/es6.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("core-js/modules/es6.regexp.replace");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

require("core-js/modules/es6.array.for-each");

require("core-js/modules/es6.promise");

require("core-js/modules/es6.object.to-string");

require("regenerator-runtime/runtime");

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _debug = _interopRequireDefault(require("debug"));

var _koaCompose = _interopRequireDefault(require("koa-compose"));

var _invariant = _interopRequireDefault(require("fbjs/lib/invariant"));

var _emptyFunction = _interopRequireDefault(require("fbjs/lib/emptyFunction"));

var _outputFileSync = _interopRequireDefault(require("output-file-sync"));

var _address = _interopRequireDefault(require("address"));

var _handleUnhandledRejection = _interopRequireDefault(require("@cat-org/utils/lib/handleUnhandledRejection"));

var _requireModule = _interopRequireDefault(require("@cat-org/utils/lib/requireModule"));

var _mockChoice = _interopRequireDefault(require("@cat-org/utils/lib/mockChoice"));

var _Cache = _interopRequireDefault(require("./utils/Cache"));

var _getConfig = _interopRequireDefault(require("./utils/getConfig"));

var _buildJs = _interopRequireDefault(require("./utils/buildJs"));

var _buildStatic = _interopRequireDefault(require("./utils/buildStatic"));

var _server = _interopRequireDefault(require("./utils/server"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(0, _handleUnhandledRejection["default"])();
var debugLog = (0, _debug["default"])('react');
/** koa-react */

var React =
/**
 * @example
 * new React('folder path')
 *
 * @param {string} folderPath - folder path
 * @param {optionsType} options - koa-react options
 */
function React(folderPath) {
  var _this = this;

  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref$dev = _ref.dev,
      _dev = _ref$dev === void 0 ? true : _ref$dev,
      _ref$config = _ref.config,
      configFunc = _ref$config === void 0 ? _emptyFunction["default"].thatReturnsArgument : _ref$config,
      _ref$handler = _ref.handler,
      handler = _ref$handler === void 0 ? _emptyFunction["default"].thatReturnsArgument : _ref$handler,
      _basename = _ref.basename,
      exclude = _ref.exclude;

  _classCallCheck(this, React);

  this.store = void 0;

  this.update = function (filePath) {
    _this.store.cache.update(filePath);
  };

  this.buildJs =
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee() {
    var _this$store, config, basenamePath, urlsFilePath, publicPath, chunkNames;

    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _this$store = _this.store, config = _this$store.config, basenamePath = _this$store.basenamePath, urlsFilePath = _this$store.urlsFilePath; // FIXME: avoid to trigger webpack again

            _context.next = 3;
            return new Promise(function (resolve) {
              return setTimeout(resolve, 1000);
            });

          case 3:
            (0, _invariant["default"])(config.config.output && config.config.output.publicPath, '`{ publicPath }` in `config.config.output` can not be null');
            publicPath = config.config.output.publicPath;
            _context.next = 7;
            return (0, _buildJs["default"])(config);

          case 7:
            chunkNames = _context.sent;
            debugLog(chunkNames);
            ['client', 'commons'].forEach(function (key) {
              var name = "".concat(basenamePath).concat(key);
              if (chunkNames[name]) _this.store.urls["".concat(key, "Url")] = "".concat(publicPath).concat(chunkNames[name]);
            });
            debugLog(_this.store.urls);
            (0, _outputFileSync["default"])(urlsFilePath, JSON.stringify(_this.store.urls));

          case 12:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  this.buildStatic =
  /*#__PURE__*/
  function () {
    var _ref3 = _asyncToGenerator(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee2(options) {
      var _this$store2, cache, urls, urlsFilePath;

      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _this$store2 = _this.store, cache = _this$store2.cache, urls = _this$store2.urls, urlsFilePath = _this$store2.urlsFilePath;

              if (!urlsFilePath) {
                _context2.next = 10;
                break;
              }

              _context2.prev = 2;
              _this.store.urls = (0, _requireModule["default"])(urlsFilePath);
              _context2.next = 10;
              break;

            case 6:
              _context2.prev = 6;
              _context2.t0 = _context2["catch"](2);

              if (/Cannot find module/.test(_context2.t0.message)) {
                _context2.next = 10;
                break;
              }

              throw _context2.t0;

            case 10:
              _context2.next = 12;
              return (0, _buildStatic["default"])(cache, urls.commonsUrl, options);

            case 12:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, null, [[2, 6]]);
    }));

    return function (_x) {
      return _ref3.apply(this, arguments);
    };
  }();

  this.middleware =
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee4() {
    var _this$store3, cache, dev, config, basename, urls, urlsFilePath, _config$config$output, urlsPath, publicPath;

    return _regenerator["default"].wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _this$store3 = _this.store, cache = _this$store3.cache, dev = _this$store3.dev, config = _this$store3.config, basename = _this$store3.basename, urls = _this$store3.urls, urlsFilePath = _this$store3.urlsFilePath;
            (0, _invariant["default"])(config.config.output && (dev || config.config.output.path && config.config.output.publicPath), '`{ path, publicPath }` in `config.config.output` can not be null');
            _config$config$output = config.config.output, urlsPath = _config$config$output.path, publicPath = _config$config$output.publicPath;
            _context4.prev = 3;
            if (!dev && urlsFilePath) _this.store.urls = (0, _requireModule["default"])(urlsFilePath);
            _context4.next = 11;
            break;

          case 7:
            _context4.prev = 7;
            _context4.t0 = _context4["catch"](3);
            (0, _invariant["default"])(!/Cannot find module/.test(_context4.t0.message), 'Use buildJs before running prod mode');
            throw _context4.t0;

          case 11:
            _context4.next = 13;
            return new Promise(function (resolve) {
              return setTimeout(resolve, 1000);
            });

          case 13:
            _context4.t1 = _koaCompose["default"];

            if (!dev) {
              _context4.next = 20;
              break;
            }

            _context4.next = 17;
            return (0, _mockChoice["default"])(process.env.NODE_ENV === 'test', _emptyFunction["default"].thatReturns(
            /*#__PURE__*/
            function () {
              var _ref5 = _asyncToGenerator(
              /*#__PURE__*/
              _regenerator["default"].mark(function _callee3(ctx, next) {
                return _regenerator["default"].wrap(function _callee3$(_context3) {
                  while (1) {
                    switch (_context3.prev = _context3.next) {
                      case 0:
                        _context3.next = 2;
                        return next();

                      case 2:
                      case "end":
                        return _context3.stop();
                    }
                  }
                }, _callee3);
              }));

              return function (_x2, _x3) {
                return _ref5.apply(this, arguments);
              };
            }()), require('koa-webpack'), config);

          case 17:
            _context4.t2 = _context4.sent;
            _context4.next = 21;
            break;

          case 20:
            _context4.t2 = require('koa-mount')(publicPath, require('koa-static')(urlsPath));

          case 21:
            _context4.t3 = _context4.t2;
            _context4.t4 = (0, _server["default"])(basename, cache, urls);
            _context4.t5 = [_context4.t3, _context4.t4];
            return _context4.abrupt("return", (0, _context4.t1)(_context4.t5));

          case 25:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4, null, [[3, 7]]);
  }));
  (0, _invariant["default"])(_fs["default"].existsSync(folderPath), "`".concat(_path["default"].relative(process.cwd(), folderPath), "` folder can not be found."));
  debugLog({
    folderPath: folderPath,
    dev: _dev,
    basename: _basename
  });

  var _cache = new _Cache["default"](folderPath, handler, _basename, exclude);

  var _config = configFunc({
    config: (0, _getConfig["default"])(_dev, folderPath, _basename, exclude, _cache),
    devMiddleware: {
      stats: {
        maxModules: 0,
        colors: true
      }
    },
    hotClient: {
      logLevel: 'warn',
      host: _address["default"].ip()
    }
  }, _dev);

  (0, _invariant["default"])(_config.config.output && _config.config.output.publicPath, '`{  publicPath }` in `config.config.output` can not be null');
  var _config$config$output2 = _config.config.output,
      _urlsPath = _config$config$output2.path,
      _publicPath = _config$config$output2.publicPath;

  var _basenamePath = _basename ? "".concat(_basename.replace(/^\//, ''), "/") : '';

  this.store = {
    cache: _cache,
    dev: _dev,
    config: _config,
    basename: _basename,
    basenamePath: _basenamePath,
    urls: {
      clientUrl: "".concat(_publicPath).concat(_basenamePath, "client.js"),
      commonsUrl: "".concat(_publicPath).concat(_basenamePath, "commons.js")
    },
    urlsFilePath: !_urlsPath ? null : _path["default"].resolve(_urlsPath, _basenamePath, 'urls.json')
  };
  debugLog(this.store);
}
/**
 * @example
 * react.update('filePath')
 *
 * @param {string} filePath - file path to watch
 */
;

exports["default"] = React;
module.exports = exports.default;