"use strict";

require("core-js/modules/es6.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("core-js/modules/es6.string.link");

var _react = _interopRequireDefault(require("react"));

var _reactHelmet = require("react-helmet");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/** @react render the html */
var Document = function Document(_ref) {
  var helmet = _ref.helmet,
      children = _ref.children;
  return _react["default"].createElement("html", {
    lang: "en"
  }, _react["default"].createElement("head", null, helmet.meta.toComponent(), helmet.title.toComponent(), helmet.link.toComponent()), _react["default"].createElement("body", null, children, helmet.script.toComponent()));
};
/**
 * @example
 * Document.getInitialProps({ ctx })
 *
 * @return {propsType} - initial props
 */


Document.getInitialProps = function () {
  return {
    // Reference: https://github.com/joshbuchea/HEAD
    head: _react["default"].createElement(_reactHelmet.Helmet, null, _react["default"].createElement("meta", {
      charSet: "utf-8"
    }), _react["default"].createElement("meta", {
      name: "viewport",
      content: "width=device-width, initial-scale=1"
    }), _react["default"].createElement("title", null, "cat-org"), _react["default"].createElement("link", {
      rel: "stylesheet",
      href: "https://necolas.github.io/normalize.css/8.0.1/normalize.css"
    }))
  };
};

var _default = _react["default"].memo(Document);

exports["default"] = _default;
module.exports = exports.default;