"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("core-js/modules/es6.promise");

require("core-js/modules/es6.object.define-properties");

require("core-js/modules/es7.object.get-own-property-descriptors");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

require("core-js/modules/es6.object.define-property");

require("core-js/modules/es6.string.iterator");

require("core-js/modules/es6.array.from");

require("core-js/modules/es6.regexp.to-string");

require("core-js/modules/es6.date.to-string");

require("core-js/modules/es6.object.to-string");

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.is-array");

require("core-js/modules/es6.function.name");

require("core-js/modules/es6.array.for-each");

require("core-js/modules/es6.array.filter");

require("core-js/modules/es6.regexp.constructor");

require("core-js/modules/es6.array.map");

require("core-js/modules/es6.regexp.replace");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

require("regenerator-runtime/runtime");

var _path = _interopRequireDefault(require("path"));

var _debug = _interopRequireDefault(require("debug"));

var _findCacheDir = _interopRequireDefault(require("find-cache-dir"));

var _outputFileSync = _interopRequireDefault(require("output-file-sync"));

var _d3DirTree = _interopRequireDefault(require("@cat-org/utils/lib/d3DirTree"));

var _requireModule = _interopRequireDefault(require("@cat-org/utils/lib/requireModule"));

var _NotFound = _interopRequireDefault(require("../templates/NotFound"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var debugLog = (0, _debug["default"])('react:Cache');
/**
 * @example
 * getLoader('/file-path')
 *
 * @param {string} filePath - file path to get loader
 *
 * @return {Function} - loader
 */

var getLoader = function getLoader(filePath) {
  return (
    /*#__PURE__*/
    _asyncToGenerator(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee() {
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              return _context.abrupt("return", {
                "default": (0, _requireModule["default"])(filePath)
              });

            case 1:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }))
  );
};
/** Cache to store the parse data */


var Cache =
/**
 * @example
 * new cache('/folder-path', () => {})
 *
 * @param {string} folderPath - folder path
 * @param {Function} handler - handler url path
 * @param {string} basename - basename to join url
 * @param {RegExp} exclude - exclude file path
 */
function Cache(_folderPath, _handler, _basename, _exclude) {
  var _this = this;

  _classCallCheck(this, Cache);

  this.store = void 0;
  this.routesData = void 0;
  this.document = void 0;
  this.main = void 0;
  this.loading = void 0;
  this.error = void 0;
  this.cacheDir = void 0;

  this.handleFilePath = function (filePath, callback) {
    var folderPath = _this.store.folderPath;

    var relativePath = _path["default"].relative(folderPath, filePath).replace(/\.jsx?$/, '');

    debugLog(relativePath);
    if (/^\.templates/.test(relativePath)) switch (relativePath.replace(/^\.templates\//, '')) {
      case 'Document':
        _this.document = filePath;
        callback('document', relativePath);
        return;

      case 'Main':
        _this.main = filePath;
        callback('main', relativePath);
        return;

      case 'Loading':
        _this.loading = filePath;
        callback('loading', relativePath);
        return;

      case 'Error':
        _this.error = filePath;
        callback('error', relativePath);
        return;

      case 'NotFound':
        _this.routesData = [].concat(_toConsumableArray(_this.routesData.slice(0, _this.routesData.length - 1)), [_objectSpread({}, _this.routesData[_this.routesData.length - 1], {
          component: _objectSpread({}, _this.routesData[_this.routesData.length - 1].component, {
            filePath: filePath,
            loader: getLoader(filePath)
          })
        })]);
        callback('not-found', relativePath);
        return;

      default:
        return;
    }
    callback('page', relativePath);
  };

  this.getPath = function (relativePath) {
    var basename = _this.store.basename;
    var routePath = [relativePath.replace(/(\/?index)?$/, '').replace(/^/, '/').replace(/\/\[([^[\]]*)\]/g, '/:$1')];
    debugLog(routePath);
    return !basename ? routePath : routePath.map(function (prevPath) {
      return "".concat(basename).concat(prevPath);
    });
  };

  this.writeFile = function (filename, content) {
    debugLog(filename, content);
    (0, _outputFileSync["default"])(_this.cacheDir(filename), content);
  };

  this.clientRoutesData = function () {
    return "module.exports = [".concat(_this.routesData.map(function (_ref2) {
      var routePath = _ref2.path,
          _ref2$component = _ref2.component,
          filePath = _ref2$component.filePath,
          chunkName = _ref2$component.chunkName;
      return "{ ".concat(['exact: true', "path: ".concat(JSON.stringify(routePath)), "component: { ".concat(["chunkName: '".concat(chunkName, "'"), "loader: () => import(/* webpackChunkName: \"".concat(chunkName, "\" */ '").concat(filePath, "')")].join(', '), " }")].join(', '), " }");
    }).join(', '), "]");
  };

  this.update = function (filePath) {
    var _this$store = _this.store,
        folderPath = _this$store.folderPath,
        basename = _this$store.basename,
        exclude = _this$store.exclude,
        handler = _this$store.handler;
    if (exclude && exclude.test(filePath)) return;
    if (!new RegExp(_path["default"].resolve(folderPath)).test(filePath)) return;

    _this.handleFilePath(filePath, function (type, relativePath) {
      switch (type) {
        case 'document':
          break;

        case 'main':
          _this.writeFile('Main.js', "module.exports = require('".concat(_this.main, "').default || require('").concat(_this.main, "');"));

          break;

        case 'loading':
          _this.writeFile('Loading.js', "module.exports = require('".concat(_this.loading, "').default || require('").concat(_this.loading, "');"));

          break;

        case 'error':
          _this.writeFile('Error.js', "module.exports = require('".concat(_this.error, "').default || require('").concat(_this.error, "');"));

          break;

        case 'not-found':
          _this.writeFile('routesData.js', _this.clientRoutesData());

          break;

        default:
          var chunkName = "pages".concat(basename || '', "/").concat(relativePath);
          _this.routesData = [{
            exact: true,
            path: _this.getPath(relativePath),
            component: {
              filePath: filePath,
              chunkName: chunkName,
              loader: getLoader(filePath)
            }
          }].concat(_toConsumableArray(_this.routesData.filter(function (_ref3) {
            var routeChunkName = _ref3.component.chunkName;
            return routeChunkName !== chunkName;
          })));
          _this.routesData = handler(_this.routesData);

          _this.writeFile('routesData.js', _this.clientRoutesData());

          break;
      }
    });
  };

  this.store = {
    folderPath: _folderPath,
    handler: _handler,
    basename: _basename,
    exclude: _exclude
  };
  this.routesData = [{
    exact: true,
    path: ["".concat(_basename || '', "/*")],
    component: {
      filePath: _path["default"].resolve(__dirname, '../templates/NotFound.js'),
      chunkName: "pages".concat(_basename || '', "/notFound"),
      loader: function () {
        var _loader = _asyncToGenerator(
        /*#__PURE__*/
        _regenerator["default"].mark(function _callee2() {
          return _regenerator["default"].wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  return _context2.abrupt("return", {
                    "default": _NotFound["default"]
                  });

                case 1:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2);
        }));

        function loader() {
          return _loader.apply(this, arguments);
        }

        return loader;
      }()
    }
  }];
  this.document = _path["default"].resolve(__dirname, '../templates/Document.js');
  this.main = _path["default"].resolve(__dirname, '../templates/Main.js');
  this.loading = _path["default"].resolve(__dirname, '../templates/Loading.js');
  this.error = _path["default"].resolve(__dirname, '../templates/Error.js');
  this.cacheDir = (0, _findCacheDir["default"])({
    name: _basename || 'no-basename',
    thunk: true
  });
  (0, _d3DirTree["default"])(_folderPath, {
    extensions: /.jsx?$/,
    exclude: _exclude
  }).leaves().forEach(function (_ref4) {
    var _ref4$data = _ref4.data,
        name = _ref4$data.name,
        filePath = _ref4$data.path;

    _this.handleFilePath(filePath, function (type, relativePath) {
      switch (type) {
        case 'document':
        case 'main':
        case 'loading':
        case 'error':
        case 'not-found':
          break;

        default:
          _this.routesData = [{
            exact: true,
            path: _this.getPath(relativePath),
            component: {
              filePath: filePath,
              chunkName: "pages".concat(_basename || '', "/").concat(relativePath),
              loader: getLoader(filePath)
            }
          }].concat(_toConsumableArray(_this.routesData));
          break;
      }
    });
  });
  this.routesData = _handler(this.routesData);
  this.writeFile('routesData.js', this.clientRoutesData());
  this.writeFile('Main.js', "module.exports = require('".concat(this.main, "').default || require('").concat(this.main, "');"));
  this.writeFile('Loading.js', "module.exports = require('".concat(this.loading, "').default || require('").concat(this.loading, "');"));
  this.writeFile('Error.js', "module.exports = require('".concat(this.error, "').default || require('").concat(this.error, "');"));
}
/**
 * @example
 * cache.handleFilePath('/file-path', () => {})
 *
 * @param {string} filePath - file path
 * @param {Function} callback - callback function to handle the file
 */
;

exports["default"] = Cache;
module.exports = exports.default;