"use strict";

require("core-js/modules/es6.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("core-js/modules/es6.regexp.to-string");

require("core-js/modules/es6.date.to-string");

require("core-js/modules/es6.promise");

require("core-js/modules/es6.object.to-string");

var _debug = _interopRequireDefault(require("debug"));

var _webpack = _interopRequireDefault(require("webpack"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var debugLog = (0, _debug["default"])('react:buildJs');
/**
 * @example
 * buildJs(config)
 *
 * @param {configType} config - koa webpack config
 *
 * @return {{ string: string }} - js filenames which are build from webpack
 */

var _default = function _default(_ref) {
  var config = _ref.config,
      logStats = _ref.devMiddleware.stats;
  return new Promise(function (resolve, reject) {
    (0, _webpack["default"])(config, function (err, stats) {
      debugLog(err);

      if (err) {
        if (err.details) reject(err.details);else reject(err);
        return;
      }

      if (stats.hasErrors()) {
        reject(stats.toJson().errors);
        return;
      }

      var _console = console,
          log = _console.log;
      log(stats.toString({
        logStats: logStats,
        colors: true
      }));
      resolve(stats.toJson().assetsByChunkName);
    });
  });
};

exports["default"] = _default;
module.exports = exports.default;