"use strict";

require("core-js/modules/es6.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("core-js/modules/es6.array.from");

require("core-js/modules/es6.regexp.to-string");

require("core-js/modules/es6.date.to-string");

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.array.is-array");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

require("core-js/modules/es6.regexp.replace");

require("core-js/modules/es6.array.filter");

require("core-js/modules/es6.array.reduce");

require("core-js/modules/es6.array.map");

require("core-js/modules/es6.promise");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.to-string");

require("core-js/modules/es6.string.iterator");

require("regenerator-runtime/runtime");

var _path = _interopRequireDefault(require("path"));

var _debug = _interopRequireDefault(require("debug"));

var _nodeFetch = _interopRequireDefault(require("node-fetch"));

var _outputFileSync = _interopRequireDefault(require("output-file-sync"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var debugLog = (0, _debug["default"])('react:buildStatic');
/**
 * @example
 * urlParamsWarning('/:id')
 *
 * @param {string} route - route string
 */

var urlParamsWarning = function urlParamsWarning(route) {
  var _console = console,
      warn = _console.warn;
  warn("You should not use the url parameters with building static: ".concat(route));
  warn("Use \"urlParamsRedirect\" in the options with building static.");
};
/**
 * @example
 * buildStatic(data, '/commons-url', options)
 *
 * @param {CacheType} cache - cache data
 * @param {string} commonsUrl - commons url
 * @param {optionsType} options - build static options
 */


var _default =
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee2(cache, commonsUrl) {
    var _ref2,
        _ref2$baseUrl,
        baseUrl,
        _ref2$folderPath,
        folderPath,
        _ref2$urlParamsRedire,
        urlParamsRedirect,
        _args2 = arguments;

    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _ref2 = _args2.length > 2 && _args2[2] !== undefined ? _args2[2] : {}, _ref2$baseUrl = _ref2.baseUrl, baseUrl = _ref2$baseUrl === void 0 ? 'http://localhost:8000' : _ref2$baseUrl, _ref2$folderPath = _ref2.folderPath, folderPath = _ref2$folderPath === void 0 ? _path["default"].resolve('./docs') : _ref2$folderPath, _ref2$urlParamsRedire = _ref2.urlParamsRedirect, urlParamsRedirect = _ref2$urlParamsRedire === void 0 ? urlParamsWarning : _ref2$urlParamsRedire;
            _context2.next = 3;
            return Promise.all(cache.routesData.reduce(function (result, _ref3) {
              var routePath = _ref3.path;
              return [].concat(_toConsumableArray(result), _toConsumableArray(routePath.map(function (route) {
                return !/\/:/.test(route) ? route : // $FlowFixMe TODO: https://github.com/facebook/flow/issues/1414
                urlParamsRedirect(route);
              }).filter(function (route) {
                return route;
              })));
            }, [commonsUrl]).map(
            /*#__PURE__*/
            function () {
              var _ref4 = _asyncToGenerator(
              /*#__PURE__*/
              _regenerator["default"].mark(function _callee(routePath) {
                var filePath;
                return _regenerator["default"].wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        filePath = _path["default"].resolve(folderPath, ".".concat(routePath.replace(/\*$/, 'notFound')), /\.js$/.test(routePath) ? '' : './index.html');
                        debugLog({
                          routePath: routePath,
                          filePath: filePath
                        });
                        _context.t0 = _outputFileSync["default"];
                        _context.t1 = filePath;
                        _context.next = 6;
                        return (0, _nodeFetch["default"])("".concat(baseUrl).concat(routePath)).then(function (res) {
                          return res.text();
                        });

                      case 6:
                        _context.t2 = _context.sent;
                        (0, _context.t0)(_context.t1, _context.t2);

                      case 8:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));

              return function (_x3) {
                return _ref4.apply(this, arguments);
              };
            }()));

          case 3:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

exports["default"] = _default;
module.exports = exports.default;