"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("core-js/modules/es6.string.iterator");

require("core-js/modules/es6.array.from");

require("core-js/modules/es6.regexp.to-string");

require("core-js/modules/es6.date.to-string");

require("core-js/modules/es6.object.to-string");

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.is-array");

require("core-js/modules/es6.object.define-property");

require("core-js/modules/es6.regexp.replace");

var _path = _interopRequireDefault(require("path"));

var _webpack = _interopRequireDefault(require("webpack"));

var _terserWebpackPlugin = _interopRequireDefault(require("terser-webpack-plugin"));

var _progressBarWebpackPlugin = _interopRequireDefault(require("progress-bar-webpack-plugin"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var CLIENT_PATH = _path["default"].resolve(__dirname, './client.js');

var ROOT_PATH = _path["default"].resolve(__dirname, './Root.js');
/**
 * @example
 * getConfig(true, '/folder-path', '/', data)
 *
 * @param {boolean} dev - is dev or not
 * @param {string} folderPath - folder path
 * @param {string} basename - basename to join url
 * @param {RegExp} exclude - exclude file path
 * @param {CacheType} cache - cache data
 *
 * @return {object} - webpack config
 */


var _default = function _default(dev, folderPath, basename, exclude, cache) {
  return {
    mode: dev ? 'development' : 'production',
    devtool: dev ? 'eval' : false,
    entry: !basename ? {
      client: [CLIENT_PATH]
    } : _defineProperty({}, "".concat(basename.replace(/^\//, ''), "/client"), [CLIENT_PATH]),
    output: {
      path: dev ? undefined : _path["default"].resolve('./public/js'),
      publicPath: dev ? '/assets/' : '/public/js/',
      filename: dev ? '[name].js' : '[name].[chunkhash:8].min.js',
      chunkFilename: dev ? '[name].js' : '[name].[chunkhash:8].min.js'
    },
    optimization: {
      minimize: !dev,
      minimizer: [new _terserWebpackPlugin["default"]({
        parallel: true,
        sourceMap: false,
        cache: true
      })],
      splitChunks: {
        chunks: 'all',
        cacheGroups: {
          "default": false,
          vendors: false,
          commons: {
            name: !basename ? 'commons' : "".concat(basename.replace(/^\//, ''), "/commons"),
            chunks: 'all',
            minChunks: cache.routesData.length > 2 ? cache.routesData.length * 0.5 : 2
          }
        }
      }
    },
    plugins: [new _webpack["default"].EnvironmentPlugin({
      BROWSER: true
    }), new _progressBarWebpackPlugin["default"]()],
    module: {
      rules: [{
        test: /\.jsx?$/,
        include: [CLIENT_PATH],
        loader: _path["default"].resolve(__dirname, './replaceLoader.js'),
        options: {
          type: 'routers',
          cacheDir: cache.cacheDir()
        }
      }].concat(_toConsumableArray(!dev ? [] : [{
        test: /\.jsx?$/,
        include: [CLIENT_PATH],
        loader: _path["default"].resolve(__dirname, './replaceLoader.js'),
        options: {
          type: 'set-config'
        }
      }, {
        test: /\.jsx?$/,
        include: [folderPath, ROOT_PATH],
        exclude: exclude,
        loader: _path["default"].resolve(__dirname, './replaceLoader.js'),
        options: {
          type: 'react-hot-loader'
        }
      }, {
        test: /\.jsx?$/,
        include: /node_modules/,
        use: ['react-hot-loader/webpack']
      }]))
    }
  };
};

exports["default"] = _default;
module.exports = exports.default;