"use strict";

require("core-js/modules/es6.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = _default;

require("core-js/modules/es6.regexp.replace");

var _crypto = _interopRequireDefault(require("crypto"));

var _debug = _interopRequireDefault(require("debug"));

var _invariant = _interopRequireDefault(require("fbjs/lib/invariant"));

var _loaderUtils = require("loader-utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var debugLog = (0, _debug["default"])('react:replaceLoader');
/**
 * @example
 * replaceLoader(source)
 *
 * @param {string} source - source string
 *
 * @return {string} - new string
 */

function _default(source) {
  // eslint-disable-next-line babel/no-invalid-this
  var _ref = (0, _loaderUtils.getOptions)(this) || {},
      type = _ref.type,
      cacheDir = _ref.cacheDir;

  var newSource = source;
  debugLog({
    type: type,
    cacheDir: cacheDir
  });

  switch (type) {
    case 'routers':
      newSource = source.replace(/['"]((?!['"]).|\/)*templates\/(Main|Loading|Error|routesData)['"]/g, "\"".concat(cacheDir, "/$2\""));
      break;

    case 'set-config':
      newSource = source.replace(/\/\*\* setConfig \*\//, "require('react-hot-loader').setConfig || ");
      break;

    case 'react-hot-loader':
      {
        var key = "_replace_".concat(_crypto["default"].createHmac('sha256', source).digest('hex').slice(0, 5));
        if (/module\.exports/.test(source)) newSource = "".concat(source.replace(/module\.exports/g, "var ".concat(key)), "\n\nif (require('react-is').isMemo(").concat(key, "))\n  require('hoist-non-react-statics')(").concat(key, ", ").concat(key, ".type);\n\nmodule.exports = require('react-hot-loader/root').hot(").concat(key, ");");else if (/exports\["default"\]/.test(source)) newSource = "".concat(source.replace(/exports\["default"\]/g, "var ".concat(key)), "\n\nif (require('react-is').isMemo(").concat(key, "))\n  require('hoist-non-react-statics')(").concat(key, ", ").concat(key, ".type);\n\nexports[\"default\"] = require('react-hot-loader/root').hot(").concat(key, ");");
        break;
      }

    default:
      throw new Error('Replace type error');
  }

  debugLog({
    source: source,
    newSource: newSource
  });
  (0, _invariant["default"])(newSource !== source, "Replace failed: ".concat(type));
  return newSource;
}

module.exports = exports.default;