"use strict";

require("core-js/modules/es6.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("core-js/modules/es6.object.assign");

require("core-js/modules/es6.regexp.to-string");

require("core-js/modules/es6.date.to-string");

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.array.is-array");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.array.index-of");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

require("core-js/modules/es6.promise");

require("core-js/modules/es6.object.to-string");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

require("core-js/modules/es6.regexp.split");

require("core-js/modules/es6.array.map");

require("core-js/modules/es6.regexp.constructor");

require("regenerator-runtime/runtime");

var _crypto = _interopRequireDefault(require("crypto"));

var _stream = _interopRequireDefault(require("stream"));

var _debug = _interopRequireDefault(require("debug"));

var _react = _interopRequireDefault(require("react"));

var _reactIs = require("react-is");

var _server = require("react-dom/server");

var _reactRouterDom = require("react-router-dom");

var _reactHelmet = require("react-helmet");

var _multistream = _interopRequireDefault(require("multistream"));

var _getStream = _interopRequireDefault(require("get-stream"));

var _emptyFunction = _interopRequireDefault(require("fbjs/lib/emptyFunction"));

var _requireModule = _interopRequireDefault(require("@cat-org/utils/lib/requireModule"));

var _Root = _interopRequireDefault(require("../components/Root"));

var _getPage = _interopRequireDefault(require("../components/getPage"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var debugLog = (0, _debug["default"])('react:server');
/**
 * @example
 * server('/', data, {})
 *
 * @param {string} basename - basename to join urls path
 * @param {CacheType} cache - cache data
 * @param {object} urls - urls data
 *
 * @return {koaMiddlewareType} - koa middleware
 */

var _default = function _default(basename, cache, _ref) {
  var clientUrl = _ref.clientUrl,
      commonsUrl = _ref.commonsUrl;
  return (
    /*#__PURE__*/
    function () {
      var _ref2 = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee2(ctx, next) {
        var _getInitialProps, _ref4;

        var Document, Main, ErrorComponent, _ref3, documentHead, documentInitialProps, _ref5, InitialPage, mainInitialProps, pageInitialProps, chunkName, hash, _renderToStaticMarkup, _renderToStaticMarkup2, upperDocument, lowerDocument;

        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                debugLog(ctx.path);

                if (!(commonsUrl === ctx.path)) {
                  _context2.next = 6;
                  break;
                }

                ctx.status = 200;
                ctx.type = 'application/javascript';
                ctx.body = '';
                return _context2.abrupt("return");

              case 6:
                if (!(!new RegExp(basename || '').test(ctx.path) || ctx.accepts('html') !== 'html')) {
                  _context2.next = 10;
                  break;
                }

                _context2.next = 9;
                return next();

              case 9:
                return _context2.abrupt("return");

              case 10:
                ctx.status = 200;
                ctx.type = 'text/html';
                ctx.respond = false;
                Document = (0, _requireModule["default"])(cache.document);
                Main = (0, _requireModule["default"])(cache.main);
                ErrorComponent = (0, _requireModule["default"])(cache.error); // [start] preload
                // preload Document, Main, Page

                _context2.next = 18;
                return (_getInitialProps = (_ref4 = !(0, _reactIs.isMemo)(Document) ? Document : Document.type).getInitialProps) === null || _getInitialProps === void 0 ? void 0 : _getInitialProps.call(_ref4, {
                  ctx: ctx,
                  isServer: true
                });

              case 18:
                _context2.t0 = _context2.sent;

                if (_context2.t0) {
                  _context2.next = 21;
                  break;
                }

                _context2.t0 = {};

              case 21:
                _ref3 = _context2.t0;
                documentHead = _ref3.head;
                documentInitialProps = _objectWithoutProperties(_ref3, ["head"]);
                (0, _server.renderToStaticMarkup)(documentHead || null);
                _context2.next = 27;
                return (0, _getPage["default"])(Main, cache.routesData, ctx, true);

              case 27:
                _ref5 = _context2.sent;
                InitialPage = _ref5.Page;
                mainInitialProps = _ref5.mainProps;
                pageInitialProps = _ref5.pageProps;
                chunkName = _ref5.chunkName;
                debugLog({
                  documentInitialProps: documentInitialProps,
                  mainInitialProps: mainInitialProps,
                  pageInitialProps: pageInitialProps,
                  chunkName: chunkName
                }); // preload scripts

                (0, _server.renderToStaticMarkup)(_react["default"].createElement(_reactHelmet.Helmet, null, _react["default"].createElement("script", null, "var __CAT_DATA__ = ".concat(JSON.stringify({
                  mainInitialProps: mainInitialProps,
                  pageInitialProps: pageInitialProps,
                  chunkName: chunkName
                }), ";")), _react["default"].createElement("script", {
                  src: commonsUrl,
                  async: true
                }), _react["default"].createElement("script", {
                  src: clientUrl,
                  async: true
                }))); // [end] preload
                // make document scream

                hash = _crypto["default"].createHmac('sha256', '@cat-org/koa-react').digest('hex');
                _renderToStaticMarkup = (0, _server.renderToStaticMarkup)(_react["default"].createElement(Document, _extends({}, documentInitialProps, {
                  helmet: _reactHelmet.Helmet.renderStatic()
                }), _react["default"].createElement("main", {
                  id: "__CAT__"
                }, hash))).split(hash).map(function (docmentText) {
                  var docmentStream = new _stream["default"].Readable();
                  docmentStream.push(docmentText);
                  docmentStream.push(null);
                  return docmentStream;
                }), _renderToStaticMarkup2 = _slicedToArray(_renderToStaticMarkup, 2), upperDocument = _renderToStaticMarkup2[0], lowerDocument = _renderToStaticMarkup2[1]; // render page

                ctx.res.write('<!DOCTYPE html>');
                new _multistream["default"]([upperDocument, (0, _server.renderToNodeStream)(_react["default"].createElement(_reactRouterDom.StaticRouter, {
                  location: ctx.url,
                  context: {}
                }, _react["default"].createElement(_Root["default"], {
                  Main: Main,
                  Loading: _emptyFunction["default"].thatReturnsNull,
                  Error: ErrorComponent,
                  routesData: cache.routesData,
                  InitialPage: InitialPage,
                  mainInitialProps: mainInitialProps,
                  pageInitialProps: pageInitialProps
                }))), lowerDocument]).on('error',
                /*#__PURE__*/
                function () {
                  var _ref6 = _asyncToGenerator(
                  /*#__PURE__*/
                  _regenerator["default"].mark(function _callee(error) {
                    return _regenerator["default"].wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            _context.t0 = ctx.res;
                            _context.t1 = "".concat((0, _server.renderToString)(_react["default"].createElement(ErrorComponent, {
                              error: error,
                              errorInfo: {
                                componentStack: ''
                              }
                            })));
                            _context.next = 4;
                            return (0, _getStream["default"])(lowerDocument);

                          case 4:
                            _context.t2 = _context.sent;
                            _context.t3 = _context.t1.concat.call(_context.t1, _context.t2);

                            _context.t0.end.call(_context.t0, _context.t3);

                          case 7:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _callee);
                  }));

                  return function (_x3) {
                    return _ref6.apply(this, arguments);
                  };
                }()).pipe(ctx.res);

              case 38:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      return function (_x, _x2) {
        return _ref2.apply(this, arguments);
      };
    }()
  );
};

exports["default"] = _default;
module.exports = exports.default;